Help us improve by taking our short survey: https://www.hdfgroup.org/website-survey/

| HDF5 Last Updated on 2026-07-28 The HDF5 Field Guide

Loading...
Searching...
No Matches
DSetMemXferPropList Class Reference

`#include <c++/src/H5DxferProp.h>`

## Detailed Description

Class DSetCreatPropList inherits from PropList and provides wrappers for the HDF5 dataset memory and transfer property list.

Inheritance diagram for DSetMemXferPropList:

## Public Member Functions
| DSetMemXferPropList ()
| Default constructor: creates a stub dataset memory and transfer property list object.
| DSetMemXferPropList (const char *expression)
| Creates a dataset transfer property list with transform expression.
| DSetMemXferPropList (const DSetMemXferPropList &orig)
| Copy constructor: same HDF5 object as original DSetMemXferPropList object.
| DSetMemXferPropList (const hid_t plist_id)
| Creates a DSetMemXferPropList object using the id of an existing DSetMemXferPropList.
virtual std::string | fromClass () const override
| Returns this class name.
void | getBtreeRatios (double &left, double &middle, double &right) const
| Gets B-tree split ratios for a dataset transfer property list.
size_t | getBuffer (void **tconv, void **bkg) const
| Reads buffer settings.
std::string | getDataTransform () const
| This is an overloaded member function, provided for convenience. It takes no parameter and returns a `H5std_string` for the expression.
ssize_t | getDataTransform (char *exp, size_t buf_size=0) const
| Sets data transform expression.
H5Z_EDC_t | getEDCCheck () const
| Determines whether error-detection is enabled for dataset reads.
size_t | getHyperVectorSize () const
| Returns the number of I/O vectors to be read/written in hyperslab I/O.
bool | getPreserve () const
| Checks status of the dataset transfer property list.
hsize_t | getSmallDataBlockSize () const
| Returns the current small data block size setting.
void | getTypeConvCB (H5T_conv_except_func_t *op, void **user_data) const
| Gets the exception handling callback function and data.
void | getVlenMemManager (H5MM_allocate_t &alloc, void **alloc_info, H5MM_free_t &free, void **free_info) const
| Gets the memory manager for variable-length datatype allocation.
void | setBtreeRatios (double left, double middle, double right) const
| Sets B-tree split ratios for a dataset transfer property list.
void | setBuffer (size_t size, void *tconv, void *bkg) const
| Sets type conversion and background buffers.
void | setDataTransform (const char *expression) const
| Sets data transform expression.
void | setDataTransform (const std::string &expression) const
| This is an overloaded member function, provided for convenience. It takes a reference to a `H5std_string` for the expression.
void | setEDCCheck (H5Z_EDC_t check) const
| Enables or disables error-detecting for a dataset reading process.
void | setHyperVectorSize (size_t vector_size) const
| Sets number of I/O vectors to be read/written in hyperslab I/O.
void | setPreserve (bool status) const
| Sets the dataset transfer property list status to true or false.
void | setSmallDataBlockSize (hsize_t size) const
| Sets the size of a contiguous block reserved for small data.
void | setTypeConvCB (H5T_conv_except_func_t op, void *user_data) const
| Sets an exception handling callback for datatype conversion for a dataset transfer property list.
void | setVlenMemManager () const
| Sets the memory manager for variable-length datatype allocation - system `malloc` and `free` will be used.
void | setVlenMemManager (H5MM_allocate_t alloc, void *alloc_info, H5MM_free_t free, void *free_info) const
| Sets the memory manager for variable-length datatype allocation.
virtual | ~DSetMemXferPropList () override=default
Public Member Functions inherited from PropList
virtual void | close () override
| Closes the property list if it is not a default one.
void | closeClass () const
| Close a property list class.
void | copy (const PropList &like_plist)
| Makes a copy of an existing property list.
void | copyProp (PropList &dest, const char *name) const
| Copies a property from this property list or class to another.
void | copyProp (PropList &dest, const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | copyProp (PropList &dest, PropList &src, const char *name) const
| Copies a property from one list or class to another - Obsolete.
void | copyProp (PropList &dest, PropList &src, const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts. - Obsolete.
hid_t | getClass () const
| Returns the class of this property list, i.e. `H5P_FILE_CREATE`...
std::string | getClassName () const
| Return the name of a generic property list class.
PropList | getClassParent () const
| Returns the parent class of a generic property class.
virtual hid_t | getId () const override
| Get the id of this property list.
size_t | getNumProps () const
| Returns the number of properties in this property list or class.
std::string | getProperty (const char *name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | getProperty (const char *name, void *value) const
| Query the value of a property in a property list.
std::string | getProperty (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | getProperty (const std::string &name, void *value) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
size_t | getPropSize (const char *name) const
| Query the size of a property in a property list or class.
size_t | getPropSize (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
bool | isAClass (const PropList &prop_class) const
| Determines whether a property list is a certain class.
PropList & | operator= (const PropList &rhs)
| Assignment operator.
bool | operator== (const PropList &rhs) const
| Compares this property list or class against the given list or class.
bool | propExist (const char *name) const
| Query the existence of a property in a property object.
bool | propExist (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
| PropList ()
| Default constructor: creates a stub property list object.
| PropList (const hid_t plist_id)
| Creates a property list using the id of an existing property.
| PropList (const PropList &original)
| Copy constructor: same HDF5 object as original.
void | removeProp (const char *name) const
| Removes a property from a property list.
void | removeProp (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const char *name, const char *charptr) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const char *name, const std::string &strg) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const char *name, const void *value) const
| Set a property's value in a property list.
void | setProperty (const char *name, std::string &strg) const
| Deprecated due to missing const in prototype. (1.10.1).
void | setProperty (const char *name, void *value) const
| Deprecated due to missing const in prototype. (1.10.1).
void | setProperty (const std::string &name, const std::string &strg) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const std::string &name, const void *value) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const std::string &name, std::string &strg) const
| Deprecated due to missing const in prototype. (1.10.1).
void | setProperty (const std::string &name, void *value) const
| Deprecated due to missing const in prototype. (1.10.1).
virtual | ~PropList () override
| Properly terminates access to this property list.
Public Member Functions inherited from IdComponent
void | decRefCount () const
| Decrement reference counter for the id of this object.
void | decRefCount (const hid_t obj_id) const
| Decrement reference counter for a given id.
int | getCounter () const
| Returns the reference counter for the id of this object.
int | getCounter (const hid_t obj_id) const
| Returns the reference counter for a given id.
H5I_type_t | getHDFObjType () const
| Returns the type of the object. It is an overloaded function of the above function.
void | incRefCount () const
| Increment reference counter for the id of this object.
void | incRefCount (const hid_t obj_id) const
| Increment reference counter for a given id.
std::string | inMemFunc (const char *func_name) const
| Makes and returns string "<class-name>::<func_name>".
IdComponent & | operator= (const IdComponent &rhs)
| Assignment operator.
void | setId (const hid_t new_id)
| Sets the identifier of this object to a new value.
virtual | ~IdComponent ()=default

## Static Public Member Functions
static void | deleteConstants ()
Static Public Member Functions inherited from PropList
static void | deleteConstants ()
Static Public Member Functions inherited from IdComponent
static H5I_type_t | getHDFObjType (const hid_t obj_id)
| Given an id, returns the type of the object.
static hsize_t | getNumMembers (H5I_type_t type)
| Returns the number of members of the given type.
static bool | isValid (hid_t an_id)
| Checks if the given ID is valid.
static bool | typeExists (H5I_type_t type)
| Queries if a given type is currently registered with the library.

## Static Public Attributes
static const DSetMemXferPropList & | DEFAULT = *getConstant()
| Default dataset memory and transfer property list.
Static Public Attributes inherited from PropList
static const PropList & | DEFAULT = *getConstant()
| Default property list.

## Additional Inherited Members
Protected Member Functions inherited from PropList
virtual void | p_setId (const hid_t new_id) override
| Sets the identifier of this object to a new value.
Protected Member Functions inherited from IdComponent
| IdComponent ()
| Default constructor.
std::string | p_get_file_name () const
Static Protected Member Functions inherited from IdComponent
static bool | p_valid_id (const hid_t obj_id)
Protected Attributes inherited from PropList
hid_t | id
Static Protected Attributes inherited from IdComponent
static bool | H5dontAtexit_called = false

## Constructor & Destructor Documentation

## ◆ DSetMemXferPropList() [1/4]

DSetMemXferPropList | ( |  | ) |

Default constructor: creates a stub dataset memory and transfer property list object.

## ◆ DSetMemXferPropList() [2/4]

DSetMemXferPropList | ( | const char * | expression | ) |

Creates a dataset transfer property list with transform expression.

## ◆ DSetMemXferPropList() [3/4]

DSetMemXferPropList | ( | const DSetMemXferPropList & | original | ) |

Copy constructor: same HDF5 object as original DSetMemXferPropList object.

Parameters

  original | - IN: Original dataset memory and transfer property list object to copy

## ◆ DSetMemXferPropList() [4/4]

DSetMemXferPropList | ( | const hid_t | plist_id | ) |

Creates a DSetMemXferPropList object using the id of an existing DSetMemXferPropList.

Parameters

  plist_id | - IN: Id of an existing dataset memory and transfer property list

## ◆ ~DSetMemXferPropList()

virtual ~DSetMemXferPropList | ( |  | ) |
| override virtual default

## Member Function Documentation

## ◆ deleteConstants()

void deleteConstants | ( |  | ) |
| static

## ◆ fromClass()

virtual std::string fromClass | ( |  | ) | const
| override virtual

Returns this class name.

Reimplemented from PropList.

## ◆ getBtreeRatios()

void getBtreeRatios | ( | double & | left,
|  | double & | middle,
|  | double & | right ) const

Gets B-tree split ratios for a dataset transfer property list.

Parameters

  left | - OUT: B-tree split ratio for left-most nodes
  middle | - OUT: B-tree split ratio for right-most nodes and lone nodes
  right | - OUT: B-tree split ratio for all other nodes

Exceptions

  H5::PropListIException |

## ◆ getBuffer()

size_t getBuffer | ( | void ** | tconv,
|  | void ** | bkg ) const

Reads buffer settings.

Parameters

  tconv | - OUT: Pointer to application-allocated type conversion buf
  bkg | - OUT: Pointer to application-allocated background buffer

Returns
  Buffer size, in bytes

Exceptions

  H5::PropListIException |

## ◆ getDataTransform() [1/2]

std::string getDataTransform | ( |  | ) | const

This is an overloaded member function, provided for convenience. It takes no parameter and returns a `H5std_string` for the expression.

Exceptions

  H5::PropListIException |

## ◆ getDataTransform() [2/2]

ssize_t getDataTransform | ( | char * | exp,
|  | size_t | buf_size = 0 ) const

Sets data transform expression.

Parameters

  exp | - OUT: buffer for data transform expression (char*)
  buf_size | - IN: size of buffer for expression, including the null terminator

Exceptions

  H5::PropListIException |

## ◆ getEDCCheck()

H5Z_EDC_t getEDCCheck | ( |  | ) | const

Determines whether error-detection is enabled for dataset reads.

Returns
  `H5Z_ENABLE_EDC` or `H5Z_DISABLE_EDC`

Exceptions

  H5::PropListIException |

## ◆ getHyperVectorSize()

size_t getHyperVectorSize | ( |  | ) | const

Returns the number of I/O vectors to be read/written in hyperslab I/O.

Returns
  Number of I/O vectors

Exceptions

  H5::PropListIException |

## ◆ getPreserve()

bool getPreserve | ( |  | ) | const

Checks status of the dataset transfer property list.

Returns
  Status of the dataset transfer property list

Exceptions

  H5::PropListIException |

## ◆ getSmallDataBlockSize()

hsize_t getSmallDataBlockSize | ( |  | ) | const

Returns the current small data block size setting.

Returns
  Size of the small data block, in bytes

Exceptions

  H5::PropListIException |

## ◆ getTypeConvCB()

void getTypeConvCB | ( | H5T_conv_except_func_t * | op,
|  | void ** | user_data ) const

Gets the exception handling callback function and data.

Parameters

  op | - IN: Retrieved user function
  user_data | - IN: Retrieved user data

Exceptions

  H5::PropListIException |

## ◆ getVlenMemManager()

void getVlenMemManager | ( | H5MM_allocate_t & | alloc_func,
|  | void ** | alloc_info,
|  | H5MM_free_t & | free_func,
|  | void ** | free_info ) const

Gets the memory manager for variable-length datatype allocation.

Parameters

  alloc_func | - OUT: User's allocate routine
  alloc_info | - OUT: User's allocation parameters
  free_func | - OUT: User's free routine
  free_info | - OUT: User's free parameters

Exceptions

  H5::PropListIException |

## ◆ setBtreeRatios()

void setBtreeRatios | ( | double | left,
|  | double | middle,
|  | double | right ) const

Sets B-tree split ratios for a dataset transfer property list.

Parameters

  left | - IN: B-tree split ratio for left-most nodes
  middle | - IN: B-tree split ratio for right-most nodes and lone nodes
  right | - IN: B-tree split ratio for all other nodes

Exceptions

  H5::PropListIException |

## ◆ setBuffer()

void setBuffer | ( | size_t | size,
|  | void * | tconv,
|  | void * | bkg ) const

Sets type conversion and background buffers.

Parameters

  size | - IN: Size, in bytes, of the type conversion and background buffers
  tconv | - IN: Pointer to application-allocated type conversion buffer
  bkg | - IN: Pointer to application-allocated background buffer

Exceptions

  H5::PropListIException |

## ◆ setDataTransform() [1/2]

void setDataTransform | ( | const char * | expression | ) | const

Sets data transform expression.

Parameters

  expression | - IN: null-terminated data transform expression (char*)

Exceptions

  H5::PropListIException |

## ◆ setDataTransform() [2/2]

void setDataTransform | ( | const std::string & | expression | ) | const

This is an overloaded member function, provided for convenience. It takes a reference to a `H5std_string` for the expression.

Parameters

  expression | - IN: H5std_string data transform expression

Exceptions

  H5::PropListIException |

## ◆ setEDCCheck()

void setEDCCheck | ( | H5Z_EDC_t | check | ) | const

Enables or disables error-detecting for a dataset reading process.

Parameters

  check | - IN: Specifies whether error detection is enabled or disabled

Exceptions

  H5::PropListIException |

Description
  The error detection algorithm used is the algorithm previously specified in the corresponding dataset creation property list. This function does not affect the use of error detection in the writing process.

  Valid values are as follows:
  - `H5Z_ENABLE_EDC` (default)
  - `H5Z_DISABLE_EDC`

## ◆ setHyperVectorSize()

void setHyperVectorSize | ( | size_t | vector_size | ) | const

Sets number of I/O vectors to be read/written in hyperslab I/O.

Exceptions

  H5::PropListIException |

Description
  For detail, please refer to the H5Pset_hyper_vector_size API in the HDF5 C Reference Manual.

## ◆ setPreserve()

void setPreserve | ( | bool | status | ) | const

Sets the dataset transfer property list status to true or false.

Parameters

  status | - IN: Status to set, true or false

Exceptions

  H5::PropListIException |

## ◆ setSmallDataBlockSize()

void setSmallDataBlockSize | ( | hsize_t | size | ) | const

Sets the size of a contiguous block reserved for small data.

Parameters

  size | - IN: Maximum size, in bytes, of the small data block.

Exceptions

  H5::PropListIException |

Description
  For detail, please refer to the H5Pset_small_data_block_size API in the HDF5 C Reference Manual.

## ◆ setTypeConvCB()

void setTypeConvCB | ( | H5T_conv_except_func_t | op,
|  | void * | user_data ) const

Sets an exception handling callback for datatype conversion for a dataset transfer property list.

Parameters

  op | - IN: User's function
  user_data | - IN: User's data

Exceptions

  H5::PropListIException |

## ◆ setVlenMemManager() [1/2]

void setVlenMemManager | ( |  | ) | const

Sets the memory manager for variable-length datatype allocation - system `malloc` and `free` will be used.

Exceptions

  H5::PropListIException |

## ◆ setVlenMemManager() [2/2]

void setVlenMemManager | ( | H5MM_allocate_t | alloc_func,
|  | void * | alloc_info,
|  | H5MM_free_t | free_func,
|  | void * | free_info ) const

Sets the memory manager for variable-length datatype allocation.

Parameters

  alloc_func | - IN: User's allocate routine
  alloc_info | - IN: User's allocation parameters
  free_func | - IN: User's free routine
  free_info | - IN: User's free parameters

Exceptions

  H5::PropListIException |

## Field Documentation

## ◆ DEFAULT

const DSetMemXferPropList & DEFAULT = *getConstant()
| static

Default dataset memory and transfer property list.

The documentation for this class was generated from the following files:

- c++/src/H5DxferProp.h
- c++/src/H5DxferProp.cpp